HTTP/1.0 200 OK
Connection: close
Server: localProxy
Content-type: application/x-ns-proxy-autoconfig

function FindProxyForURL (url, host) {
  // $Revision: 4.19 $
  // proxy.pac to be served to browsers by localProxy back end.
  // 1. Internet Explorer and Outlook Express share the same
  // http proxy. A proxy.pac allows OE to use a special set of
  // PROPFIND proxies for it's web based email accounts.
  // 2. allows us a rudimentary form of ad-zapping and maybe
  // popup removal (this is in the new Mozilla though, so not so
  // important now).
  // 3. allows us to point the browser to fast, censoring proxies
  // where we know it's ok. E.g. to windowsupdate.microsoft.com.
  // 4. allows us to handle the transparent proxy case, where the
  // 'fast, censoring' connection is direct (e.g. adsl). Not
  // implemented yet.

  // XXX todo: get all of the info above into the localProxy config,
  // and change variables in this file on the fly. Also make lp
  // substitute it's own address automatically.
  // browser address is myIpAddress()
  // XXX - make browser use no proxy when it's accessing a web site within
  // it's known firewall subnets.

  // Note that activating *any* of the alerts below will invalidate
  // this script for Mozilla use (the browser will then attempt to
  // access web sites without any proxy and probably fail).

  host = host.toLowerCase();
  var str;

  // following addresses are dynamically changed by localProxy, if necessary
  var lpHost = "127.0.0.1"; // where lp is running
  var mySubnets = ""; // we don't need a proxy at all for these.

  // XXX localProxy will substitute the right values below automatically
  var transProxy = 0; //transparent proxy connection (e.g. ADSL)?
  var fastCensor = lpHost + ":10080"; // put your ISP proxy and port here

  //XXX - disable these extra ports if LP isn't running them!
  //XXX - needs to be automatically substituted by LP
  if (shExpMatch(url, "https*")) {
    // return "DIRECT";
    // alert( "https" );
    str = "PROXY " + lpHost + ":10076";
    return str;
    };

  // To address hosts in the client's accessible (uncensored) neighborhood
  // we insist his requested URL contains only a plain (undotted) hostname
  // Other possibilities exist, but involve knowledge of his acccessible
  // neighborhood mask, and many dns lookups.

  // The plain hostname check by itself would cause browser
  // to go direct when presented with a 32bit host address (commStrat 2)
  // They don't reach here normally, but the user may copy to the address
  // bar (and probably fail because the Host: header will then also be this
  // 32bit number); or one day I might make LP rewrite links :-)
  // XXX - the check below doesn't work since 3com got their way :-(
  // XXX - Now host names are permitted to start with a digit.
  var letter = "abcdefghijklmnopqrstuvwxyz";
  if  ((url.substring(0, 4) == "ftp:") ||
     (isPlainHostName(host) &&
     (letter.indexOf(host.charAt(0)) > -1)) ||
     shExpMatch(url, "*127.0.0*") ||
     // (host == "localhost") ||
     (url.substring(0, 5) == "file:") ||
     // also direct if host is in mySubnets
     // there may be a few false matches here, but unlikely
     // XXX - should use dns to resolve host if fqdn
     // shExpMatch(mySubnets, host)
     isInNet(host, mySubnets, "255.255.255.0"))
      {
      // alert( "direct" );
      return "DIRECT";
      };

  // ... fill in your favorite ad patterns here...
  if ((host == "ad.iwin.com") ||
    shExpMatch(url, "*.linkexchange.com/*") ||
    shExpMatch(url, "*.doubleclick.net/ad*") ||
    shExpMatch(url, "*.doubleclick.net/viewad/*") ||
    shExpMatch(url, "http://a1032.g.akamai.net/f/*") ||
    shExpMatch(url, "http://ads.web.aol.com/content/*") ||
    shExpMatch(url, "*.doubleclick.net/jump/*") ||
    shExpMatch(url, "*.msn.com/ADSAdClient*") ||
    shExpMatch(url, "*ads.msn.com/ads/*") ||
    shExpMatch(url, "http://us.a1.yimg.com/us.yimg.com/a/*") ||
    // (host == "us.a1.yimg.com") ||
    (shExpMatch(url, "http://rd.yahoo.com/M=*") && 
      !shExpMatch(url, "*\**")) ||
    shExpMatch(url, "*.msads.net/ads/*") ||
    shExpMatch(url, "http://creative.zdnet.com/adverts/*") ||
    shExpMatch(url, "*ads.osdn.com/banner/*") ||
    shExpMatch(url, "*/ads.x10.com/*") 
    ) {
      // alert( "ad blocked" );
      return "PROXY " + lpHost + ":10078";
      };

  // the shExpMatch here often fails with OE - why?
  // ok with mozilla (IE?)
  if  ( shExpMatch(url, "*oe.hotmail.com/*") ||
     ( host == "lc2.law5.hotmail.passport.com" ) ||
     ( host == "services.msn.com" ) ||
     ( host == "oe.hotmail.com" ) ||
     ( host == "law2.oe.hotmail.com" ) ||
     ( host == "law15.oe.hotmail.com" ) || 
     ( host == "sea2.oe.hotmail.com" ) ||
     ( host == "lw15fd.law15.hotmail.msn.com" ) || 
     ( host == "loginnet.passport.com" ) 
     )  {
      str = "PROXY " + lpHost + ":10077";
      return str;
      };

  // special cases - not mandatory
  if ((host == "windowsupdate.microsoft.com" )
    ) {
    if (transProxy == 1) { return "DIRECT" }
    else {
      str = "PROXY " + fastCensor;
      return str;
      }
    };

  str = "PROXY " + lpHost + ":10080";

  // alert( str );
  return str;

  };
